#include <sql.h>
#include <ch.h>

EXPORTCH SQLRETURN SQL_API SQLAllocConnect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV EnvironmentHandle;
    SQLHDBC *ConnectionHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC *);
    retval = SQLAllocConnect(EnvironmentHandle, ConnectionHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLAllocEnv_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV *EnvironmentHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV *);
    retval = SQLAllocEnv(EnvironmentHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLAllocHandle_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT HandleType;
    SQLHANDLE InputHandle;
    SQLHANDLE *OutputHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    HandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    InputHandle = Ch_VaArg(interp, ap, SQLHANDLE);
    OutputHandle = Ch_VaArg(interp, ap, SQLHANDLE *);
    retval = SQLAllocHandle(HandleType, InputHandle, OutputHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLAllocStmt_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLHSTMT *StatementHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT *);
    retval = SQLAllocStmt(ConnectionHandle, StatementHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLBindCol_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT ColumnNumber;
    SQLSMALLINT TargetType;
    SQLPOINTER TargetValue;
    SQLLEN BufferLength;
    SQLLEN *StrLen_or_Ind;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    ColumnNumber = Ch_VaArg(interp, ap, SQLUSMALLINT);
    TargetType = Ch_VaArg(interp, ap, SQLSMALLINT);
    TargetValue = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLLEN);
    StrLen_or_Ind = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLBindCol(StatementHandle, ColumnNumber, TargetType, TargetValue, BufferLength, StrLen_or_Ind);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLBindParam_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT ParameterNumber;
    SQLSMALLINT ValueType;
    SQLSMALLINT ParameterType;
    SQLULEN LengthPrecision;
    SQLSMALLINT ParameterScale;
    SQLPOINTER ParameterValue;
    SQLLEN *StrLen_or_Ind;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    ParameterNumber = Ch_VaArg(interp, ap, SQLUSMALLINT);
    ValueType = Ch_VaArg(interp, ap, SQLSMALLINT);
    ParameterType = Ch_VaArg(interp, ap, SQLSMALLINT);
    LengthPrecision = Ch_VaArg(interp, ap, SQLULEN);
    ParameterScale = Ch_VaArg(interp, ap, SQLSMALLINT);
    ParameterValue = Ch_VaArg(interp, ap, SQLPOINTER);
    StrLen_or_Ind = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLBindParam(StatementHandle, ParameterNumber, ValueType, ParameterType, LengthPrecision, ParameterScale, ParameterValue, StrLen_or_Ind);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLCancel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    retval = SQLCancel(StatementHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLCloseCursor_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    retval = SQLCloseCursor(StatementHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColAttribute_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT ColumnNumber;
    SQLUSMALLINT FieldIdentifier;
    SQLPOINTER CharacterAttribute;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *StringLength;
    SQLLEN *NumericAttribute;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    ColumnNumber = Ch_VaArg(interp, ap, SQLUSMALLINT);
    FieldIdentifier = Ch_VaArg(interp, ap, SQLUSMALLINT);
    CharacterAttribute = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    StringLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    NumericAttribute = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLColAttribute(StatementHandle, ColumnNumber, FieldIdentifier, CharacterAttribute, BufferLength, StringLength, NumericAttribute);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColumns_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLCHAR *CatalogName;
    SQLSMALLINT NameLength1;
    SQLCHAR *SchemaName;
    SQLSMALLINT NameLength2;
    SQLCHAR *TableName;
    SQLSMALLINT NameLength3;
    SQLCHAR *ColumnName;
    SQLSMALLINT NameLength4;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    CatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength1 = Ch_VaArg(interp, ap, SQLSMALLINT);
    SchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength2 = Ch_VaArg(interp, ap, SQLSMALLINT);
    TableName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength3 = Ch_VaArg(interp, ap, SQLSMALLINT);
    ColumnName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength4 = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLColumns(StatementHandle, CatalogName, NameLength1, SchemaName, NameLength2, TableName, NameLength3, ColumnName, NameLength4);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLConnect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLCHAR *ServerName;
    SQLSMALLINT NameLength1;
    SQLCHAR *UserName;
    SQLSMALLINT NameLength2;
    SQLCHAR *Authentication;
    SQLSMALLINT NameLength3;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    ServerName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength1 = Ch_VaArg(interp, ap, SQLSMALLINT);
    UserName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength2 = Ch_VaArg(interp, ap, SQLSMALLINT);
    Authentication = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength3 = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLConnect(ConnectionHandle, ServerName, NameLength1, UserName, NameLength2, Authentication, NameLength3);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLCopyDesc_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC SourceDescHandle;
    SQLHDESC TargetDescHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    SourceDescHandle = Ch_VaArg(interp, ap, SQLHDESC);
    TargetDescHandle = Ch_VaArg(interp, ap, SQLHDESC);
    retval = SQLCopyDesc(SourceDescHandle, TargetDescHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDataSources_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV EnvironmentHandle;
    SQLUSMALLINT Direction;
    SQLCHAR *ServerName;
    SQLSMALLINT BufferLength1;
    SQLSMALLINT *NameLength1;
    SQLCHAR *Description;
    SQLSMALLINT BufferLength2;
    SQLSMALLINT *NameLength2;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV);
    Direction = Ch_VaArg(interp, ap, SQLUSMALLINT);
    ServerName = Ch_VaArg(interp, ap, SQLCHAR *);
    BufferLength1 = Ch_VaArg(interp, ap, SQLSMALLINT);
    NameLength1 = Ch_VaArg(interp, ap, SQLSMALLINT *);
    Description = Ch_VaArg(interp, ap, SQLCHAR *);
    BufferLength2 = Ch_VaArg(interp, ap, SQLSMALLINT);
    NameLength2 = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDataSources(EnvironmentHandle, Direction, ServerName, BufferLength1, NameLength1, Description, BufferLength2, NameLength2);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDescribeCol_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT ColumnNumber;
    SQLCHAR *ColumnName;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *NameLength;
    SQLSMALLINT *DataType;
    SQLULEN *ColumnSize;
    SQLSMALLINT *DecimalDigits;
    SQLSMALLINT *Nullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    ColumnNumber = Ch_VaArg(interp, ap, SQLUSMALLINT);
    ColumnName = Ch_VaArg(interp, ap, SQLCHAR *);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    NameLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    DataType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    ColumnSize = Ch_VaArg(interp, ap, SQLULEN *);
    DecimalDigits = Ch_VaArg(interp, ap, SQLSMALLINT *);
    Nullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDescribeCol(StatementHandle, ColumnNumber, ColumnName, BufferLength, NameLength, DataType, ColumnSize, DecimalDigits, Nullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDisconnect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    retval = SQLDisconnect(ConnectionHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLEndTran_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT HandleType;
    SQLHANDLE Handle;
    SQLSMALLINT CompletionType;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    HandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    Handle = Ch_VaArg(interp, ap, SQLHANDLE);
    CompletionType = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLEndTran(HandleType, Handle, CompletionType);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLError_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV EnvironmentHandle;
    SQLHDBC ConnectionHandle;
    SQLHSTMT StatementHandle;
    SQLCHAR *Sqlstate;
    SQLINTEGER *NativeError;
    SQLCHAR *MessageText;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *TextLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Sqlstate = Ch_VaArg(interp, ap, SQLCHAR *);
    NativeError = Ch_VaArg(interp, ap, SQLINTEGER *);
    MessageText = Ch_VaArg(interp, ap, SQLCHAR *);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    TextLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLError(EnvironmentHandle, ConnectionHandle, StatementHandle, Sqlstate, NativeError, MessageText, BufferLength, TextLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLExecDirect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLCHAR *StatementText;
    SQLINTEGER TextLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    StatementText = Ch_VaArg(interp, ap, SQLCHAR *);
    TextLength = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLExecDirect(StatementHandle, StatementText, TextLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLExecute_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    retval = SQLExecute(StatementHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLFetch_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    retval = SQLFetch(StatementHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLFetchScroll_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLSMALLINT FetchOrientation;
    SQLLEN FetchOffset;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    FetchOrientation = Ch_VaArg(interp, ap, SQLSMALLINT);
    FetchOffset = Ch_VaArg(interp, ap, SQLLEN);
    retval = SQLFetchScroll(StatementHandle, FetchOrientation, FetchOffset);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLFreeConnect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    retval = SQLFreeConnect(ConnectionHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLFreeEnv_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV EnvironmentHandle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV);
    retval = SQLFreeEnv(EnvironmentHandle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLFreeHandle_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT HandleType;
    SQLHANDLE Handle;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    HandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    Handle = Ch_VaArg(interp, ap, SQLHANDLE);
    retval = SQLFreeHandle(HandleType, Handle);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLFreeStmt_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT Option;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Option = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLFreeStmt(StatementHandle, Option);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetConnectAttr_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLINTEGER Attribute;
    SQLPOINTER Value;
    SQLINTEGER BufferLength;
    SQLINTEGER *StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    Attribute = Ch_VaArg(interp, ap, SQLINTEGER);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLINTEGER);
    StringLength = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetConnectAttr(ConnectionHandle, Attribute, Value, BufferLength, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetConnectOption_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLUSMALLINT Option;
    SQLPOINTER Value;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    Option = Ch_VaArg(interp, ap, SQLUSMALLINT);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    retval = SQLGetConnectOption(ConnectionHandle, Option, Value);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetCursorName_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLCHAR *CursorName;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *NameLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    CursorName = Ch_VaArg(interp, ap, SQLCHAR *);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    NameLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetCursorName(StatementHandle, CursorName, BufferLength, NameLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetData_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT ColumnNumber;
    SQLSMALLINT TargetType;
    SQLPOINTER TargetValue;
    SQLLEN BufferLength;
    SQLLEN *StrLen_or_Ind;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    ColumnNumber = Ch_VaArg(interp, ap, SQLUSMALLINT);
    TargetType = Ch_VaArg(interp, ap, SQLSMALLINT);
    TargetValue = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLLEN);
    StrLen_or_Ind = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLGetData(StatementHandle, ColumnNumber, TargetType, TargetValue, BufferLength, StrLen_or_Ind);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDescRec_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC DescriptorHandle;
    SQLSMALLINT RecNumber;
    SQLCHAR *Name;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *StringLength;
    SQLSMALLINT *Type;
    SQLSMALLINT *SubType;
    SQLLEN *Length;
    SQLSMALLINT *Precision;
    SQLSMALLINT *Scale;
    SQLSMALLINT *Nullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    DescriptorHandle = Ch_VaArg(interp, ap, SQLHDESC);
    RecNumber = Ch_VaArg(interp, ap, SQLSMALLINT);
    Name = Ch_VaArg(interp, ap, SQLCHAR *);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    StringLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    Type = Ch_VaArg(interp, ap, SQLSMALLINT *);
    SubType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    Length = Ch_VaArg(interp, ap, SQLLEN *);
    Precision = Ch_VaArg(interp, ap, SQLSMALLINT *);
    Scale = Ch_VaArg(interp, ap, SQLSMALLINT *);
    Nullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDescRec(DescriptorHandle, RecNumber, Name, BufferLength, StringLength, Type, SubType, Length, Precision, Scale, Nullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDiagField_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT HandleType;
    SQLHANDLE Handle;
    SQLSMALLINT RecNumber;
    SQLSMALLINT DiagIdentifier;
    SQLPOINTER DiagInfo;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    HandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    Handle = Ch_VaArg(interp, ap, SQLHANDLE);
    RecNumber = Ch_VaArg(interp, ap, SQLSMALLINT);
    DiagIdentifier = Ch_VaArg(interp, ap, SQLSMALLINT);
    DiagInfo = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    StringLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDiagField(HandleType, Handle, RecNumber, DiagIdentifier, DiagInfo, BufferLength, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDiagRec_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT HandleType;
    SQLHANDLE Handle;
    SQLSMALLINT RecNumber;
    SQLCHAR *Sqlstate;
    SQLINTEGER *NativeError;
    SQLCHAR *MessageText;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *TextLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    HandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    Handle = Ch_VaArg(interp, ap, SQLHANDLE);
    RecNumber = Ch_VaArg(interp, ap, SQLSMALLINT);
    Sqlstate = Ch_VaArg(interp, ap, SQLCHAR *);
    NativeError = Ch_VaArg(interp, ap, SQLINTEGER *);
    MessageText = Ch_VaArg(interp, ap, SQLCHAR *);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    TextLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDiagRec(HandleType, Handle, RecNumber, Sqlstate, NativeError, MessageText, BufferLength, TextLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetEnvAttr_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV EnvironmentHandle;
    SQLINTEGER Attribute;
    SQLPOINTER Value;
    SQLINTEGER BufferLength;
    SQLINTEGER *StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV);
    Attribute = Ch_VaArg(interp, ap, SQLINTEGER);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLINTEGER);
    StringLength = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetEnvAttr(EnvironmentHandle, Attribute, Value, BufferLength, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetFunctions_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLUSMALLINT FunctionId;
    SQLUSMALLINT *Supported;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    FunctionId = Ch_VaArg(interp, ap, SQLUSMALLINT);
    Supported = Ch_VaArg(interp, ap, SQLUSMALLINT *);
    retval = SQLGetFunctions(ConnectionHandle, FunctionId, Supported);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetInfo_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLUSMALLINT InfoType;
    SQLPOINTER InfoValue;
    SQLSMALLINT BufferLength;
    SQLSMALLINT *StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    InfoType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    InfoValue = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    StringLength = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetInfo(ConnectionHandle, InfoType, InfoValue, BufferLength, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetStmtAttr_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLINTEGER Attribute;
    SQLPOINTER Value;
    SQLINTEGER BufferLength;
    SQLINTEGER *StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Attribute = Ch_VaArg(interp, ap, SQLINTEGER);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLINTEGER);
    StringLength = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetStmtAttr(StatementHandle, Attribute, Value, BufferLength, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetStmtOption_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT Option;
    SQLPOINTER Value;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Option = Ch_VaArg(interp, ap, SQLUSMALLINT);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    retval = SQLGetStmtOption(StatementHandle, Option, Value);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetTypeInfo_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLSMALLINT DataType;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    DataType = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLGetTypeInfo(StatementHandle, DataType);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLNumResultCols_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLSMALLINT *ColumnCount;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    ColumnCount = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLNumResultCols(StatementHandle, ColumnCount);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLParamData_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLPOINTER *Value;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Value = Ch_VaArg(interp, ap, SQLPOINTER *);
    retval = SQLParamData(StatementHandle, Value);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLPrepare_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLCHAR *StatementText;
    SQLINTEGER TextLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    StatementText = Ch_VaArg(interp, ap, SQLCHAR *);
    TextLength = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLPrepare(StatementHandle, StatementText, TextLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLPutData_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLPOINTER Data;
    SQLLEN StrLen_or_Ind;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Data = Ch_VaArg(interp, ap, SQLPOINTER);
    StrLen_or_Ind = Ch_VaArg(interp, ap, SQLLEN);
    retval = SQLPutData(StatementHandle, Data, StrLen_or_Ind);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLRowCount_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLLEN *RowCount;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    RowCount = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLRowCount(StatementHandle, RowCount);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetConnectAttr_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLINTEGER Attribute;
    SQLPOINTER Value;
    SQLINTEGER StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    Attribute = Ch_VaArg(interp, ap, SQLINTEGER);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    StringLength = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetConnectAttr(ConnectionHandle, Attribute, Value, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetConnectOption_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC ConnectionHandle;
    SQLUSMALLINT Option;
    SQLULEN Value;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    Option = Ch_VaArg(interp, ap, SQLUSMALLINT);
    Value = Ch_VaArg(interp, ap, SQLULEN);
    retval = SQLSetConnectOption(ConnectionHandle, Option, Value);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetCursorName_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLCHAR *CursorName;
    SQLSMALLINT NameLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    CursorName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLSetCursorName(StatementHandle, CursorName, NameLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetDescField_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC DescriptorHandle;
    SQLSMALLINT RecNumber;
    SQLSMALLINT FieldIdentifier;
    SQLPOINTER Value;
    SQLINTEGER BufferLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    DescriptorHandle = Ch_VaArg(interp, ap, SQLHDESC);
    RecNumber = Ch_VaArg(interp, ap, SQLSMALLINT);
    FieldIdentifier = Ch_VaArg(interp, ap, SQLSMALLINT);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetDescField(DescriptorHandle, RecNumber, FieldIdentifier, Value, BufferLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetDescRec_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC DescriptorHandle;
    SQLSMALLINT RecNumber;
    SQLSMALLINT Type;
    SQLSMALLINT SubType;
    SQLLEN Length;
    SQLSMALLINT Precision;
    SQLSMALLINT Scale;
    SQLPOINTER Data;
    SQLLEN *StringLength;
    SQLLEN *Indicator;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    DescriptorHandle = Ch_VaArg(interp, ap, SQLHDESC);
    RecNumber = Ch_VaArg(interp, ap, SQLSMALLINT);
    Type = Ch_VaArg(interp, ap, SQLSMALLINT);
    SubType = Ch_VaArg(interp, ap, SQLSMALLINT);
    Length = Ch_VaArg(interp, ap, SQLLEN);
    Precision = Ch_VaArg(interp, ap, SQLSMALLINT);
    Scale = Ch_VaArg(interp, ap, SQLSMALLINT);
    Data = Ch_VaArg(interp, ap, SQLPOINTER);
    StringLength = Ch_VaArg(interp, ap, SQLLEN *);
    Indicator = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLSetDescRec(DescriptorHandle, RecNumber, Type, SubType, Length, Precision, Scale, Data, StringLength, Indicator);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetEnvAttr_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV EnvironmentHandle;
    SQLINTEGER Attribute;
    SQLPOINTER Value;
    SQLINTEGER StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV);
    Attribute = Ch_VaArg(interp, ap, SQLINTEGER);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    StringLength = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetEnvAttr(EnvironmentHandle, Attribute, Value, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetParam_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT ParameterNumber;
    SQLSMALLINT ValueType;
    SQLSMALLINT ParameterType;
    SQLULEN LengthPrecision;
    SQLSMALLINT ParameterScale;
    SQLPOINTER ParameterValue;
    SQLLEN *StrLen_or_Ind;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    ParameterNumber = Ch_VaArg(interp, ap, SQLUSMALLINT);
    ValueType = Ch_VaArg(interp, ap, SQLSMALLINT);
    ParameterType = Ch_VaArg(interp, ap, SQLSMALLINT);
    LengthPrecision = Ch_VaArg(interp, ap, SQLULEN);
    ParameterScale = Ch_VaArg(interp, ap, SQLSMALLINT);
    ParameterValue = Ch_VaArg(interp, ap, SQLPOINTER);
    StrLen_or_Ind = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLSetParam(StatementHandle, ParameterNumber, ValueType, ParameterType, LengthPrecision, ParameterScale, ParameterValue, StrLen_or_Ind);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetStmtAttr_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLINTEGER Attribute;
    SQLPOINTER Value;
    SQLINTEGER StringLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Attribute = Ch_VaArg(interp, ap, SQLINTEGER);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    StringLength = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetStmtAttr(StatementHandle, Attribute, Value, StringLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetStmtOption_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT Option;
    SQLULEN Value;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    Option = Ch_VaArg(interp, ap, SQLUSMALLINT);
    Value = Ch_VaArg(interp, ap, SQLULEN);
    retval = SQLSetStmtOption(StatementHandle, Option, Value);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSpecialColumns_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLUSMALLINT IdentifierType;
    SQLCHAR *CatalogName;
    SQLSMALLINT NameLength1;
    SQLCHAR *SchemaName;
    SQLSMALLINT NameLength2;
    SQLCHAR *TableName;
    SQLSMALLINT NameLength3;
    SQLUSMALLINT Scope;
    SQLUSMALLINT Nullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    IdentifierType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    CatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength1 = Ch_VaArg(interp, ap, SQLSMALLINT);
    SchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength2 = Ch_VaArg(interp, ap, SQLSMALLINT);
    TableName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength3 = Ch_VaArg(interp, ap, SQLSMALLINT);
    Scope = Ch_VaArg(interp, ap, SQLUSMALLINT);
    Nullable = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLSpecialColumns(StatementHandle, IdentifierType, CatalogName, NameLength1, SchemaName, NameLength2, TableName, NameLength3, Scope, Nullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLStatistics_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLCHAR *CatalogName;
    SQLSMALLINT NameLength1;
    SQLCHAR *SchemaName;
    SQLSMALLINT NameLength2;
    SQLCHAR *TableName;
    SQLSMALLINT NameLength3;
    SQLUSMALLINT Unique;
    SQLUSMALLINT Reserved;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    CatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength1 = Ch_VaArg(interp, ap, SQLSMALLINT);
    SchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength2 = Ch_VaArg(interp, ap, SQLSMALLINT);
    TableName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength3 = Ch_VaArg(interp, ap, SQLSMALLINT);
    Unique = Ch_VaArg(interp, ap, SQLUSMALLINT);
    Reserved = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLStatistics(StatementHandle, CatalogName, NameLength1, SchemaName, NameLength2, TableName, NameLength3, Unique, Reserved);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLTables_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLCHAR *CatalogName;
    SQLSMALLINT NameLength1;
    SQLCHAR *SchemaName;
    SQLSMALLINT NameLength2;
    SQLCHAR *TableName;
    SQLSMALLINT NameLength3;
    SQLCHAR *TableType;
    SQLSMALLINT NameLength4;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    CatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength1 = Ch_VaArg(interp, ap, SQLSMALLINT);
    SchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength2 = Ch_VaArg(interp, ap, SQLSMALLINT);
    TableName = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength3 = Ch_VaArg(interp, ap, SQLSMALLINT);
    TableType = Ch_VaArg(interp, ap, SQLCHAR *);
    NameLength4 = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLTables(StatementHandle, CatalogName, NameLength1, SchemaName, NameLength2, TableName, NameLength3, TableType, NameLength4);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLTransact_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV EnvironmentHandle;
    SQLHDBC ConnectionHandle;
    SQLUSMALLINT CompletionType;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    EnvironmentHandle = Ch_VaArg(interp, ap, SQLHENV);
    ConnectionHandle = Ch_VaArg(interp, ap, SQLHDBC);
    CompletionType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLTransact(EnvironmentHandle, ConnectionHandle, CompletionType);
    Ch_VaEnd(interp, ap);
    return retval;
}
