#include <sql.h>
#include <sqlucode.h>
#include <ch.h>

EXPORTCH SQLRETURN SQL_API SQLColAttributeW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT iCol;
    SQLUSMALLINT iField;
    SQLPOINTER pCharAttr;
    SQLSMALLINT cbCharAttrMax;
    SQLSMALLINT *pcbCharAttr;
    SQLLEN *pNumAttr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    iCol = Ch_VaArg(interp, ap, SQLUSMALLINT);
    iField = Ch_VaArg(interp, ap, SQLUSMALLINT);
    pCharAttr = Ch_VaArg(interp, ap, SQLPOINTER);
    cbCharAttrMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbCharAttr = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pNumAttr = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLColAttributeW(hstmt, iCol, iField, pCharAttr, cbCharAttrMax, pcbCharAttr, pNumAttr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColAttributesW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT icol;
    SQLUSMALLINT fDescType;
    SQLPOINTER rgbDesc;
    SQLSMALLINT cbDescMax;
    SQLSMALLINT *pcbDesc;
    SQLLEN *pfDesc;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    icol = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fDescType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    rgbDesc = Ch_VaArg(interp, ap, SQLPOINTER);
    cbDescMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDesc = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfDesc = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLColAttributesW(hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLConnectW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLWCHAR *szDSN;
    SQLSMALLINT cbDSN;
    SQLWCHAR *szUID;
    SQLSMALLINT cbUID;
    SQLWCHAR *szAuthStr;
    SQLSMALLINT cbAuthStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szDSN = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbDSN = Ch_VaArg(interp, ap, SQLSMALLINT);
    szUID = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbUID = Ch_VaArg(interp, ap, SQLSMALLINT);
    szAuthStr = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbAuthStr = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLConnectW(hdbc, szDSN, cbDSN, szUID, cbUID, szAuthStr, cbAuthStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDescribeColW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT icol;
    SQLWCHAR *szColName;
    SQLSMALLINT cbColNameMax;
    SQLSMALLINT *pcbColName;
    SQLSMALLINT *pfSqlType;
    SQLULEN *pcbColDef;
    SQLSMALLINT *pibScale;
    SQLSMALLINT *pfNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    icol = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szColName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbColNameMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbColName = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfSqlType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pcbColDef = Ch_VaArg(interp, ap, SQLULEN *);
    pibScale = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfNullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDescribeColW(hstmt, icol, szColName, cbColNameMax, pcbColName, pfSqlType, pcbColDef, pibScale, pfNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLErrorW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV henv;
    SQLHDBC hdbc;
    SQLHSTMT hstmt;
    SQLWCHAR *szSqlState;
    SQLINTEGER *pfNativeError;
    SQLWCHAR *szErrorMsg;
    SQLSMALLINT cbErrorMsgMax;
    SQLSMALLINT *pcbErrorMsg;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    henv = Ch_VaArg(interp, ap, SQLHENV);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szSqlState = Ch_VaArg(interp, ap, SQLWCHAR *);
    pfNativeError = Ch_VaArg(interp, ap, SQLINTEGER *);
    szErrorMsg = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbErrorMsgMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbErrorMsg = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLErrorW(henv, hdbc, hstmt, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLExecDirectW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szSqlStr;
    SQLINTEGER cbSqlStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szSqlStr = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSqlStr = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLExecDirectW(hstmt, szSqlStr, cbSqlStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetConnectAttrW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLINTEGER fAttribute;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValueMax;
    SQLINTEGER *pcbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fAttribute = Ch_VaArg(interp, ap, SQLINTEGER);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbValue = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetConnectAttrW(hdbc, fAttribute, rgbValue, cbValueMax, pcbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetCursorNameW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCursor;
    SQLSMALLINT cbCursorMax;
    SQLSMALLINT *pcbCursor;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCursor = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCursorMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbCursor = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetCursorNameW(hstmt, szCursor, cbCursorMax, pcbCursor);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetDescFieldW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC DescriptorHandle;
    SQLSMALLINT RecNumber;
    SQLSMALLINT FieldIdentifier;
    SQLPOINTER Value;
    SQLINTEGER BufferLength;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    DescriptorHandle = Ch_VaArg(interp, ap, SQLHDESC);
    RecNumber = Ch_VaArg(interp, ap, SQLSMALLINT);
    FieldIdentifier = Ch_VaArg(interp, ap, SQLSMALLINT);
    Value = Ch_VaArg(interp, ap, SQLPOINTER);
    BufferLength = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetDescFieldW(DescriptorHandle, RecNumber, FieldIdentifier, Value, BufferLength);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDescFieldW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC hdesc;
    SQLSMALLINT iRecord;
    SQLSMALLINT iField;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValueMax;
    SQLINTEGER *pcbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdesc = Ch_VaArg(interp, ap, SQLHDESC);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    iField = Ch_VaArg(interp, ap, SQLSMALLINT);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbValue = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetDescFieldW(hdesc, iRecord, iField, rgbValue, cbValueMax, pcbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDescRecW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC hdesc;
    SQLSMALLINT iRecord;
    SQLWCHAR *szName;
    SQLSMALLINT cbNameMax;
    SQLSMALLINT *pcbName;
    SQLSMALLINT *pfType;
    SQLSMALLINT *pfSubType;
    SQLLEN *pLength;
    SQLSMALLINT *pPrecision;
    SQLSMALLINT *pScale;
    SQLSMALLINT *pNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdesc = Ch_VaArg(interp, ap, SQLHDESC);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    szName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbNameMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbName = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfSubType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pLength = Ch_VaArg(interp, ap, SQLLEN *);
    pPrecision = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pScale = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pNullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDescRecW(hdesc, iRecord, szName, cbNameMax, pcbName, pfType, pfSubType, pLength, pPrecision, pScale, pNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDiagFieldW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT fHandleType;
    SQLHANDLE handle;
    SQLSMALLINT iRecord;
    SQLSMALLINT fDiagField;
    SQLPOINTER rgbDiagInfo;
    SQLSMALLINT cbDiagInfoMax;
    SQLSMALLINT *pcbDiagInfo;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    fHandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    handle = Ch_VaArg(interp, ap, SQLHANDLE);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    fDiagField = Ch_VaArg(interp, ap, SQLSMALLINT);
    rgbDiagInfo = Ch_VaArg(interp, ap, SQLPOINTER);
    cbDiagInfoMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDiagInfo = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDiagFieldW(fHandleType, handle, iRecord, fDiagField, rgbDiagInfo, cbDiagInfoMax, pcbDiagInfo);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDiagRecW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT fHandleType;
    SQLHANDLE handle;
    SQLSMALLINT iRecord;
    SQLWCHAR *szSqlState;
    SQLINTEGER *pfNativeError;
    SQLWCHAR *szErrorMsg;
    SQLSMALLINT cbErrorMsgMax;
    SQLSMALLINT *pcbErrorMsg;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    fHandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    handle = Ch_VaArg(interp, ap, SQLHANDLE);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSqlState = Ch_VaArg(interp, ap, SQLWCHAR *);
    pfNativeError = Ch_VaArg(interp, ap, SQLINTEGER *);
    szErrorMsg = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbErrorMsgMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbErrorMsg = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDiagRecW(fHandleType, handle, iRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLPrepareW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szSqlStr;
    SQLINTEGER cbSqlStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szSqlStr = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSqlStr = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLPrepareW(hstmt, szSqlStr, cbSqlStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetConnectAttrW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLINTEGER fAttribute;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fAttribute = Ch_VaArg(interp, ap, SQLINTEGER);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValue = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetConnectAttrW(hdbc, fAttribute, rgbValue, cbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetCursorNameW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCursor;
    SQLSMALLINT cbCursor;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCursor = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCursor = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLSetCursorNameW(hstmt, szCursor, cbCursor);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColumnsW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLWCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLColumnsW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetConnectOptionW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLUSMALLINT fOption;
    SQLPOINTER pvParam;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fOption = Ch_VaArg(interp, ap, SQLUSMALLINT);
    pvParam = Ch_VaArg(interp, ap, SQLPOINTER);
    retval = SQLGetConnectOptionW(hdbc, fOption, pvParam);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetInfoW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLUSMALLINT fInfoType;
    SQLPOINTER rgbInfoValue;
    SQLSMALLINT cbInfoValueMax;
    SQLSMALLINT *pcbInfoValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fInfoType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    rgbInfoValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbInfoValueMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbInfoValue = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetInfoW(hdbc, fInfoType, rgbInfoValue, cbInfoValueMax, pcbInfoValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetTypeInfoW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLSMALLINT DataType;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    DataType = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLGetTypeInfoW(StatementHandle, DataType);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetConnectOptionW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLUSMALLINT fOption;
    SQLULEN vParam;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fOption = Ch_VaArg(interp, ap, SQLUSMALLINT);
    vParam = Ch_VaArg(interp, ap, SQLULEN);
    retval = SQLSetConnectOptionW(hdbc, fOption, vParam);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSpecialColumnsW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT fColType;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLUSMALLINT fScope;
    SQLUSMALLINT fNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fColType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    fScope = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fNullable = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLSpecialColumnsW(hstmt, fColType, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, fScope, fNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLStatisticsW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLUSMALLINT fUnique;
    SQLUSMALLINT fAccuracy;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    fUnique = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fAccuracy = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLStatisticsW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, fUnique, fAccuracy);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLTablesW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLWCHAR *szTableType;
    SQLSMALLINT cbTableType;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableType = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableType = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLTablesW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szTableType, cbTableType);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDataSourcesW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV henv;
    SQLUSMALLINT fDirection;
    SQLWCHAR *szDSN;
    SQLSMALLINT cbDSNMax;
    SQLSMALLINT *pcbDSN;
    SQLWCHAR *szDescription;
    SQLSMALLINT cbDescriptionMax;
    SQLSMALLINT *pcbDescription;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    henv = Ch_VaArg(interp, ap, SQLHENV);
    fDirection = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szDSN = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbDSNMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDSN = Ch_VaArg(interp, ap, SQLSMALLINT *);
    szDescription = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbDescriptionMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDescription = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDataSourcesW(henv, fDirection, szDSN, cbDSNMax, pcbDSN, szDescription, cbDescriptionMax, pcbDescription);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDriverConnectW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLHWND hwnd;
    SQLWCHAR *szConnStrIn;
    SQLSMALLINT cbConnStrIn;
    SQLWCHAR *szConnStrOut;
    SQLSMALLINT cbConnStrOutMax;
    SQLSMALLINT *pcbConnStrOut;
    SQLUSMALLINT fDriverCompletion;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    hwnd = Ch_VaArg(interp, ap, SQLHWND);
    szConnStrIn = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbConnStrIn = Ch_VaArg(interp, ap, SQLSMALLINT);
    szConnStrOut = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbConnStrOutMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbConnStrOut = Ch_VaArg(interp, ap, SQLSMALLINT *);
    fDriverCompletion = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLDriverConnectW(hdbc, hwnd, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, fDriverCompletion);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLBrowseConnectW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLWCHAR *szConnStrIn;
    SQLSMALLINT cbConnStrIn;
    SQLWCHAR *szConnStrOut;
    SQLSMALLINT cbConnStrOutMax;
    SQLSMALLINT *pcbConnStrOut;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szConnStrIn = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbConnStrIn = Ch_VaArg(interp, ap, SQLSMALLINT);
    szConnStrOut = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbConnStrOutMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbConnStrOut = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLBrowseConnectW(hdbc, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColumnPrivilegesW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLWCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLColumnPrivilegesW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetStmtAttrW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLINTEGER fAttribute;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValueMax;
    SQLINTEGER *pcbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fAttribute = Ch_VaArg(interp, ap, SQLINTEGER);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbValue = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetStmtAttrW(hstmt, fAttribute, rgbValue, cbValueMax, pcbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetStmtAttrW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLINTEGER fAttribute;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValueMax;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fAttribute = Ch_VaArg(interp, ap, SQLINTEGER);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetStmtAttrW(hstmt, fAttribute, rgbValue, cbValueMax);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLForeignKeysW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szPkCatalogName;
    SQLSMALLINT cbPkCatalogName;
    SQLWCHAR *szPkSchemaName;
    SQLSMALLINT cbPkSchemaName;
    SQLWCHAR *szPkTableName;
    SQLSMALLINT cbPkTableName;
    SQLWCHAR *szFkCatalogName;
    SQLSMALLINT cbFkCatalogName;
    SQLWCHAR *szFkSchemaName;
    SQLSMALLINT cbFkSchemaName;
    SQLWCHAR *szFkTableName;
    SQLSMALLINT cbFkTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szPkCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbPkCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szPkSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbPkSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szPkTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbPkTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbFkCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbFkSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbFkTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLForeignKeysW(hstmt, szPkCatalogName, cbPkCatalogName, szPkSchemaName, cbPkSchemaName, szPkTableName, cbPkTableName, szFkCatalogName, cbFkCatalogName, szFkSchemaName, cbFkSchemaName, szFkTableName, cbFkTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLNativeSqlW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLWCHAR *szSqlStrIn;
    SQLINTEGER cbSqlStrIn;
    SQLWCHAR *szSqlStr;
    SQLINTEGER cbSqlStrMax;
    SQLINTEGER *pcbSqlStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szSqlStrIn = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSqlStrIn = Ch_VaArg(interp, ap, SQLINTEGER);
    szSqlStr = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSqlStrMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbSqlStr = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLNativeSqlW(hdbc, szSqlStrIn, cbSqlStrIn, szSqlStr, cbSqlStrMax, pcbSqlStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLPrimaryKeysW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLPrimaryKeysW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLProcedureColumnsW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szProcName;
    SQLSMALLINT cbProcName;
    SQLWCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szProcName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbProcName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLProcedureColumnsW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szProcName, cbProcName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLProceduresW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szProcName;
    SQLSMALLINT cbProcName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szProcName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbProcName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLProceduresW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szProcName, cbProcName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLTablePrivilegesW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLWCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLWCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLWCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLTablePrivilegesW(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDriversW_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV henv;
    SQLUSMALLINT fDirection;
    SQLWCHAR *szDriverDesc;
    SQLSMALLINT cbDriverDescMax;
    SQLSMALLINT *pcbDriverDesc;
    SQLWCHAR *szDriverAttributes;
    SQLSMALLINT cbDrvrAttrMax;
    SQLSMALLINT *pcbDrvrAttr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    henv = Ch_VaArg(interp, ap, SQLHENV);
    fDirection = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szDriverDesc = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbDriverDescMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDriverDesc = Ch_VaArg(interp, ap, SQLSMALLINT *);
    szDriverAttributes = Ch_VaArg(interp, ap, SQLWCHAR *);
    cbDrvrAttrMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDrvrAttr = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDriversW(henv, fDirection, szDriverDesc, cbDriverDescMax, pcbDriverDesc, szDriverAttributes, cbDrvrAttrMax, pcbDrvrAttr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColAttributeA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLSMALLINT iCol;
    SQLSMALLINT iField;
    SQLPOINTER pCharAttr;
    SQLSMALLINT cbCharAttrMax;
    SQLSMALLINT *pcbCharAttr;
    SQLLEN *pNumAttr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    iCol = Ch_VaArg(interp, ap, SQLSMALLINT);
    iField = Ch_VaArg(interp, ap, SQLSMALLINT);
    pCharAttr = Ch_VaArg(interp, ap, SQLPOINTER);
    cbCharAttrMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbCharAttr = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pNumAttr = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLColAttributeA(hstmt, iCol, iField, pCharAttr, cbCharAttrMax, pcbCharAttr, pNumAttr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColAttributesA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT icol;
    SQLUSMALLINT fDescType;
    SQLPOINTER rgbDesc;
    SQLSMALLINT cbDescMax;
    SQLSMALLINT *pcbDesc;
    SQLLEN *pfDesc;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    icol = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fDescType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    rgbDesc = Ch_VaArg(interp, ap, SQLPOINTER);
    cbDescMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDesc = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfDesc = Ch_VaArg(interp, ap, SQLLEN *);
    retval = SQLColAttributesA(hstmt, icol, fDescType, rgbDesc, cbDescMax, pcbDesc, pfDesc);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLConnectA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLCHAR *szDSN;
    SQLSMALLINT cbDSN;
    SQLCHAR *szUID;
    SQLSMALLINT cbUID;
    SQLCHAR *szAuthStr;
    SQLSMALLINT cbAuthStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szDSN = Ch_VaArg(interp, ap, SQLCHAR *);
    cbDSN = Ch_VaArg(interp, ap, SQLSMALLINT);
    szUID = Ch_VaArg(interp, ap, SQLCHAR *);
    cbUID = Ch_VaArg(interp, ap, SQLSMALLINT);
    szAuthStr = Ch_VaArg(interp, ap, SQLCHAR *);
    cbAuthStr = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLConnectA(hdbc, szDSN, cbDSN, szUID, cbUID, szAuthStr, cbAuthStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDescribeColA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT icol;
    SQLCHAR *szColName;
    SQLSMALLINT cbColNameMax;
    SQLSMALLINT *pcbColName;
    SQLSMALLINT *pfSqlType;
    SQLULEN *pcbColDef;
    SQLSMALLINT *pibScale;
    SQLSMALLINT *pfNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    icol = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szColName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbColNameMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbColName = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfSqlType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pcbColDef = Ch_VaArg(interp, ap, SQLULEN *);
    pibScale = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfNullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDescribeColA(hstmt, icol, szColName, cbColNameMax, pcbColName, pfSqlType, pcbColDef, pibScale, pfNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLErrorA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV henv;
    SQLHDBC hdbc;
    SQLHSTMT hstmt;
    SQLCHAR *szSqlState;
    SQLINTEGER *pfNativeError;
    SQLCHAR *szErrorMsg;
    SQLSMALLINT cbErrorMsgMax;
    SQLSMALLINT *pcbErrorMsg;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    henv = Ch_VaArg(interp, ap, SQLHENV);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szSqlState = Ch_VaArg(interp, ap, SQLCHAR *);
    pfNativeError = Ch_VaArg(interp, ap, SQLINTEGER *);
    szErrorMsg = Ch_VaArg(interp, ap, SQLCHAR *);
    cbErrorMsgMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbErrorMsg = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLErrorA(henv, hdbc, hstmt, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLExecDirectA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szSqlStr;
    SQLINTEGER cbSqlStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szSqlStr = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSqlStr = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLExecDirectA(hstmt, szSqlStr, cbSqlStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetConnectAttrA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLINTEGER fAttribute;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValueMax;
    SQLINTEGER *pcbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fAttribute = Ch_VaArg(interp, ap, SQLINTEGER);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbValue = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetConnectAttrA(hdbc, fAttribute, rgbValue, cbValueMax, pcbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetCursorNameA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCursor;
    SQLSMALLINT cbCursorMax;
    SQLSMALLINT *pcbCursor;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCursor = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCursorMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbCursor = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetCursorNameA(hstmt, szCursor, cbCursorMax, pcbCursor);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDescFieldA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC hdesc;
    SQLSMALLINT iRecord;
    SQLSMALLINT iField;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValueMax;
    SQLINTEGER *pcbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdesc = Ch_VaArg(interp, ap, SQLHDESC);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    iField = Ch_VaArg(interp, ap, SQLSMALLINT);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbValue = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetDescFieldA(hdesc, iRecord, iField, rgbValue, cbValueMax, pcbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDescRecA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDESC hdesc;
    SQLSMALLINT iRecord;
    SQLCHAR *szName;
    SQLSMALLINT cbNameMax;
    SQLSMALLINT *pcbName;
    SQLSMALLINT *pfType;
    SQLSMALLINT *pfSubType;
    SQLLEN *pLength;
    SQLSMALLINT *pPrecision;
    SQLSMALLINT *pScale;
    SQLSMALLINT *pNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdesc = Ch_VaArg(interp, ap, SQLHDESC);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    szName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbNameMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbName = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfSubType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pLength = Ch_VaArg(interp, ap, SQLLEN *);
    pPrecision = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pScale = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pNullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDescRecA(hdesc, iRecord, szName, cbNameMax, pcbName, pfType, pfSubType, pLength, pPrecision, pScale, pNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDiagFieldA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT fHandleType;
    SQLHANDLE handle;
    SQLSMALLINT iRecord;
    SQLSMALLINT fDiagField;
    SQLPOINTER rgbDiagInfo;
    SQLSMALLINT cbDiagInfoMax;
    SQLSMALLINT *pcbDiagInfo;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    fHandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    handle = Ch_VaArg(interp, ap, SQLHANDLE);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    fDiagField = Ch_VaArg(interp, ap, SQLSMALLINT);
    rgbDiagInfo = Ch_VaArg(interp, ap, SQLPOINTER);
    cbDiagInfoMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDiagInfo = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDiagFieldA(fHandleType, handle, iRecord, fDiagField, rgbDiagInfo, cbDiagInfoMax, pcbDiagInfo);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetDiagRecA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLSMALLINT fHandleType;
    SQLHANDLE handle;
    SQLSMALLINT iRecord;
    SQLCHAR *szSqlState;
    SQLINTEGER *pfNativeError;
    SQLCHAR *szErrorMsg;
    SQLSMALLINT cbErrorMsgMax;
    SQLSMALLINT *pcbErrorMsg;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    fHandleType = Ch_VaArg(interp, ap, SQLSMALLINT);
    handle = Ch_VaArg(interp, ap, SQLHANDLE);
    iRecord = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSqlState = Ch_VaArg(interp, ap, SQLCHAR *);
    pfNativeError = Ch_VaArg(interp, ap, SQLINTEGER *);
    szErrorMsg = Ch_VaArg(interp, ap, SQLCHAR *);
    cbErrorMsgMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbErrorMsg = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLGetDiagRecA(fHandleType, handle, iRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetStmtAttrA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLINTEGER fAttribute;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValueMax;
    SQLINTEGER *pcbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fAttribute = Ch_VaArg(interp, ap, SQLINTEGER);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValueMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbValue = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLGetStmtAttrA(hstmt, fAttribute, rgbValue, cbValueMax, pcbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetTypeInfoA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT StatementHandle;
    SQLSMALLINT DataTyoe;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    StatementHandle = Ch_VaArg(interp, ap, SQLHSTMT);
    DataTyoe = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLGetTypeInfoA(StatementHandle, DataTyoe);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLPrepareA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szSqlStr;
    SQLINTEGER cbSqlStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szSqlStr = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSqlStr = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLPrepareA(hstmt, szSqlStr, cbSqlStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetConnectAttrA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLINTEGER fAttribute;
    SQLPOINTER rgbValue;
    SQLINTEGER cbValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fAttribute = Ch_VaArg(interp, ap, SQLINTEGER);
    rgbValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbValue = Ch_VaArg(interp, ap, SQLINTEGER);
    retval = SQLSetConnectAttrA(hdbc, fAttribute, rgbValue, cbValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetCursorNameA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCursor;
    SQLSMALLINT cbCursor;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCursor = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCursor = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLSetCursorNameA(hstmt, szCursor, cbCursor);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColumnsA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLColumnsA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetConnectOptionA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLUSMALLINT fOption;
    SQLPOINTER pvParam;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fOption = Ch_VaArg(interp, ap, SQLUSMALLINT);
    pvParam = Ch_VaArg(interp, ap, SQLPOINTER);
    retval = SQLGetConnectOptionA(hdbc, fOption, pvParam);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetInfoA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLUSMALLINT fInfoType;
    SQLPOINTER rgbInfoValue;
    SQLSMALLINT cbInfoValueMax;
    SQLSMALLINT* pcbInfoValue;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fInfoType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    rgbInfoValue = Ch_VaArg(interp, ap, SQLPOINTER);
    cbInfoValueMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbInfoValue = Ch_VaArg(interp, ap, SQLSMALLINT*);
    retval = SQLGetInfoA(hdbc, fInfoType, rgbInfoValue, cbInfoValueMax, pcbInfoValue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLGetStmtOptionA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT fOption;
    SQLPOINTER pvParam;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fOption = Ch_VaArg(interp, ap, SQLUSMALLINT);
    pvParam = Ch_VaArg(interp, ap, SQLPOINTER);
    retval = SQLGetStmtOptionA(hstmt, fOption, pvParam);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetConnectOptionA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLUSMALLINT fOption;
    SQLULEN vParam;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    fOption = Ch_VaArg(interp, ap, SQLUSMALLINT);
    vParam = Ch_VaArg(interp, ap, SQLULEN);
    retval = SQLSetConnectOptionA(hdbc, fOption, vParam);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSetStmtOptionA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT fOption;
    SQLULEN vParam;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fOption = Ch_VaArg(interp, ap, SQLUSMALLINT);
    vParam = Ch_VaArg(interp, ap, SQLULEN);
    retval = SQLSetStmtOptionA(hstmt, fOption, vParam);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLSpecialColumnsA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT fColType;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLUSMALLINT fScope;
    SQLUSMALLINT fNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    fColType = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    fScope = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fNullable = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLSpecialColumnsA(hstmt, fColType, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, fScope, fNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLStatisticsA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLUSMALLINT fUnique;
    SQLUSMALLINT fAccuracy;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    fUnique = Ch_VaArg(interp, ap, SQLUSMALLINT);
    fAccuracy = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLStatisticsA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, fUnique, fAccuracy);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLTablesA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLCHAR *szTableType;
    SQLSMALLINT cbTableType;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableType = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableType = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLTablesA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szTableType, cbTableType);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDataSourcesA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV henv;
    SQLUSMALLINT fDirection;
    SQLCHAR *szDSN;
    SQLSMALLINT cbDSNMax;
    SQLSMALLINT *pcbDSN;
    SQLCHAR *szDescription;
    SQLSMALLINT cbDescriptionMax;
    SQLSMALLINT *pcbDescription;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    henv = Ch_VaArg(interp, ap, SQLHENV);
    fDirection = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szDSN = Ch_VaArg(interp, ap, SQLCHAR *);
    cbDSNMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDSN = Ch_VaArg(interp, ap, SQLSMALLINT *);
    szDescription = Ch_VaArg(interp, ap, SQLCHAR *);
    cbDescriptionMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDescription = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDataSourcesA(henv, fDirection, szDSN, cbDSNMax, pcbDSN, szDescription, cbDescriptionMax, pcbDescription);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDriverConnectA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLHWND hwnd;
    SQLCHAR *szConnStrIn;
    SQLSMALLINT cbConnStrIn;
    SQLCHAR *szConnStrOut;
    SQLSMALLINT cbConnStrOutMax;
    SQLSMALLINT *pcbConnStrOut;
    SQLUSMALLINT fDriverCompletion;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    hwnd = Ch_VaArg(interp, ap, SQLHWND);
    szConnStrIn = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrIn = Ch_VaArg(interp, ap, SQLSMALLINT);
    szConnStrOut = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrOutMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbConnStrOut = Ch_VaArg(interp, ap, SQLSMALLINT *);
    fDriverCompletion = Ch_VaArg(interp, ap, SQLUSMALLINT);
    retval = SQLDriverConnectA(hdbc, hwnd, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut, fDriverCompletion);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLBrowseConnectA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLCHAR *szConnStrIn;
    SQLSMALLINT cbConnStrIn;
    SQLCHAR *szConnStrOut;
    SQLSMALLINT cbConnStrOutMax;
    SQLSMALLINT *pcbConnStrOut;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szConnStrIn = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrIn = Ch_VaArg(interp, ap, SQLSMALLINT);
    szConnStrOut = Ch_VaArg(interp, ap, SQLCHAR *);
    cbConnStrOutMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbConnStrOut = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLBrowseConnectA(hdbc, szConnStrIn, cbConnStrIn, szConnStrOut, cbConnStrOutMax, pcbConnStrOut);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLColumnPrivilegesA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLColumnPrivilegesA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDescribeParamA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLUSMALLINT ipar;
    SQLSMALLINT *pfSqlType;
    SQLUINTEGER *pcbParamDef;
    SQLSMALLINT *pibScale;
    SQLSMALLINT *pfNullable;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    ipar = Ch_VaArg(interp, ap, SQLUSMALLINT);
    pfSqlType = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pcbParamDef = Ch_VaArg(interp, ap, SQLUINTEGER *);
    pibScale = Ch_VaArg(interp, ap, SQLSMALLINT *);
    pfNullable = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDescribeParamA(hstmt, ipar, pfSqlType, pcbParamDef, pibScale, pfNullable);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLForeignKeysA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szPkCatalogName;
    SQLSMALLINT cbPkCatalogName;
    SQLCHAR *szPkSchemaName;
    SQLSMALLINT cbPkSchemaName;
    SQLCHAR *szPkTableName;
    SQLSMALLINT cbPkTableName;
    SQLCHAR *szFkCatalogName;
    SQLSMALLINT cbFkCatalogName;
    SQLCHAR *szFkSchemaName;
    SQLSMALLINT cbFkSchemaName;
    SQLCHAR *szFkTableName;
    SQLSMALLINT cbFkTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szPkCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbPkCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szPkSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbPkSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szPkTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbPkTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbFkCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbFkSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szFkTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbFkTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLForeignKeysA(hstmt, szPkCatalogName, cbPkCatalogName, szPkSchemaName, cbPkSchemaName, szPkTableName, cbPkTableName, szFkCatalogName, cbFkCatalogName, szFkSchemaName, cbFkSchemaName, szFkTableName, cbFkTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLNativeSqlA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHDBC hdbc;
    SQLCHAR *szSqlStrIn;
    SQLINTEGER cbSqlStrIn;
    SQLCHAR *szSqlStr;
    SQLINTEGER cbSqlStrMax;
    SQLINTEGER *pcbSqlStr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hdbc = Ch_VaArg(interp, ap, SQLHDBC);
    szSqlStrIn = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSqlStrIn = Ch_VaArg(interp, ap, SQLINTEGER);
    szSqlStr = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSqlStrMax = Ch_VaArg(interp, ap, SQLINTEGER);
    pcbSqlStr = Ch_VaArg(interp, ap, SQLINTEGER *);
    retval = SQLNativeSqlA(hdbc, szSqlStrIn, cbSqlStrIn, szSqlStr, cbSqlStrMax, pcbSqlStr);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLPrimaryKeysA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLPrimaryKeysA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLProcedureColumnsA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szProcName;
    SQLSMALLINT cbProcName;
    SQLCHAR *szColumnName;
    SQLSMALLINT cbColumnName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szProcName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbProcName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szColumnName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbColumnName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLProcedureColumnsA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szProcName, cbProcName, szColumnName, cbColumnName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLProceduresA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szProcName;
    SQLSMALLINT cbProcName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szProcName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbProcName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLProceduresA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szProcName, cbProcName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLTablePrivilegesA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHSTMT hstmt;
    SQLCHAR *szCatalogName;
    SQLSMALLINT cbCatalogName;
    SQLCHAR *szSchemaName;
    SQLSMALLINT cbSchemaName;
    SQLCHAR *szTableName;
    SQLSMALLINT cbTableName;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    hstmt = Ch_VaArg(interp, ap, SQLHSTMT);
    szCatalogName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbCatalogName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szSchemaName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbSchemaName = Ch_VaArg(interp, ap, SQLSMALLINT);
    szTableName = Ch_VaArg(interp, ap, SQLCHAR *);
    cbTableName = Ch_VaArg(interp, ap, SQLSMALLINT);
    retval = SQLTablePrivilegesA(hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH SQLRETURN SQL_API SQLDriversA_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    SQLHENV henv;
    SQLUSMALLINT fDirection;
    SQLCHAR *szDriverDesc;
    SQLSMALLINT cbDriverDescMax;
    SQLSMALLINT *pcbDriverDesc;
    SQLCHAR *szDriverAttributes;
    SQLSMALLINT cbDrvrAttrMax;
    SQLSMALLINT *pcbDrvrAttr;
    SQLRETURN SQL_API retval;

    Ch_VaStart(interp, ap, varg);
    henv = Ch_VaArg(interp, ap, SQLHENV);
    fDirection = Ch_VaArg(interp, ap, SQLUSMALLINT);
    szDriverDesc = Ch_VaArg(interp, ap, SQLCHAR *);
    cbDriverDescMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDriverDesc = Ch_VaArg(interp, ap, SQLSMALLINT *);
    szDriverAttributes = Ch_VaArg(interp, ap, SQLCHAR *);
    cbDrvrAttrMax = Ch_VaArg(interp, ap, SQLSMALLINT);
    pcbDrvrAttr = Ch_VaArg(interp, ap, SQLSMALLINT *);
    retval = SQLDriversA(henv, fDirection, szDriverDesc, cbDriverDescMax, pcbDriverDesc, szDriverAttributes, cbDrvrAttrMax, pcbDrvrAttr);
    Ch_VaEnd(interp, ap);
    return retval;
}
